﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using AjaxSnippets.Design;
using System.Drawing.Design;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace AjaxSnippets
{
    /// <summary>
    /// Defines a WebControl that will be used to trigger a snippet callback via the given ClientEvent
    /// </summary>
    public class CallbackTrigger
    {
        /// <summary>
        /// The WebControl ID the ClientEvent will be attach to
        /// </summary>
        [IDReferenceProperty]
        [TypeConverter(typeof(ControlIDConverter))]
        [Description("The WebControl ID the ClientEvent will be attach to")]
        public string ControlID { get; set; }

        /// <summary>
        /// A client event such as onclick, onmouseup, etc
        /// </summary>
        [Description("A client event such as onclick, onmouseup, etc")]        
        public string ClientEvent { get; set; }
    }
}
